package org.diplomaUPV.app.rest.controller;

import java.util.Date;
import java.util.List;

import org.apache.ibatis.annotations.Param;
import org.diplomaUPV.app.rest.dao.ComentarioDao;
import org.diplomaUPV.app.rest.entity.Comentario;
import org.diplomaUPV.app.rest.service.ComentarioRestService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;


@Controller
@RequestMapping("/comentarios")
public class ComentarioRestController implements ComentarioRestService{
	
	@Autowired
	private ComentarioDao comentarioDao; 
	

	@RequestMapping(value = "/getAll", method = RequestMethod.GET)
	@ResponseBody
	public List<Comentario> getComentarios() {
		return comentarioDao.getComentarios();
	}
	

    @RequestMapping(value = "/get", method = RequestMethod.GET)
    @ResponseBody
	public List<Comentario> getComentariosPorCarateristicas(
			@Param("id") Long id,
			@Param("idEvento") Long idEvento,
			@Param("fechaCreacion") Date fechaCreacion,
			@Param("textoComentario") String textoComentario,
			@Param("usuario") String usuario
			) {
    	
		Comentario comentario = new Comentario().withId(id).
				withIdEvento(idEvento).
				withFechaCreacion(fechaCreacion).
				withTextoComentario(textoComentario).
				withUsuario(usuario);
		
		return comentarioDao.getComentariosPorCarateristicas(comentario);
	}
   
    @RequestMapping(value = "/insert", method = RequestMethod.POST)
	public void insertComentario(@RequestBody Comentario comentario){
    	comentarioDao.insertComentario(comentario);
    }
    
    @RequestMapping( value = "/update/{id}", method = RequestMethod.PUT )
    public void updateComentario(@PathVariable("id") Long id, @RequestBody Comentario comentario){
    	comentarioDao.updateComentario(comentario);
    }
  

	public void setComentarioDao(ComentarioDao comentarioDao) {
		this.comentarioDao = comentarioDao;
	}

}
