package org.diplomaUPV.app.rest.controller;

import java.util.Date;
import java.util.List;

import org.apache.ibatis.annotations.Param;
import org.diplomaUPV.app.rest.dao.EventoDao;
import org.diplomaUPV.app.rest.entity.Evento;
import org.diplomaUPV.app.rest.service.EventoRestService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;


@Controller
@RequestMapping("/eventos")
public class EventoRestController implements EventoRestService{
	
	@Autowired
	private EventoDao eventoDao; 
	

	@RequestMapping(value = "/getAll", method = RequestMethod.GET)
	@ResponseBody
	public List<Evento> getEventos() {
		return eventoDao.getEventos();
	}
	

    @RequestMapping(value = "/get", method = RequestMethod.GET)
    @ResponseBody
	public List<Evento> getEventosPorCarateristicas(
			@Param("id") Long id,
			@Param("titulo") String titulo,
			@Param("idDisciplina") Long idDisciplina,
			@Param("idModalidad") Long idModalidad,
			@Param("localidad") String localidad,
			@Param("idComunidadAutonoma")Long idComunidadAutonoma,
			@Param("localidadGmaps") String localidadGmaps,
			@Param("urlEvento") String urlEvento,
			@Param("fecha") Date fecha,
			@Param("infoExtra") String infoExtra,
			@Param("fechaCreacion") Date fechaCreacion,
			@Param("urlCartel") String urlCartel,
			@Param("puntuacionPositiva") Long puntuacionPositiva, 
			@Param("puntuacionNegativa") Long puntuacionNegativa
			) {
    
    	
		Evento evento = new Evento().withId(id).
				withTitulo(titulo).
				withIdDisciplina(idDisciplina).
				withIdModalidad(idModalidad).
				withLocalidad(localidadGmaps).
				withIdComunidadAutonoma(idComunidadAutonoma).
				withLocalidadGmaps(localidadGmaps).
				withUrlEvento(urlEvento).
				withFecha(fecha).
				withInfoExtra(infoExtra).
				withFechaCreacion(fechaCreacion).
				withUrlCartel(urlCartel).
				withPuntuacionPositiva(puntuacionPositiva).
				withPuntuacionNegativa(puntuacionNegativa);
		
		return eventoDao.getEventosPorCarateristicas(evento);
	}
    
    
    @RequestMapping(value = "/insert", method = RequestMethod.POST)
  	public void insertEvento(@RequestBody Evento evento){
    	eventoDao.insertEvento(evento);
    }
    
    @RequestMapping( value = "/update/{id}", method = RequestMethod.PUT )
    public void updateEvento(@PathVariable("id") Long id, @RequestBody Evento evento){
    	eventoDao.updateEvento(evento);
    }
    
	public void setEventoDao(EventoDao eventoDao) {
		this.eventoDao = eventoDao;
	}

}
