package org.diplomaUPV.app.rest.controller;

import java.util.List;

import org.apache.ibatis.annotations.Param;
import org.diplomaUPV.app.rest.dao.ModalidadDao;
import org.diplomaUPV.app.rest.entity.Modalidad;
import org.diplomaUPV.app.rest.service.ModalidadRestService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;


@Controller
@RequestMapping("/modalidades")
public class ModalidadRestController implements ModalidadRestService{
	
	@Autowired
	private ModalidadDao modalidadDao; 
	

	@RequestMapping(value = "/getAll", method = RequestMethod.GET)
	@ResponseBody
	public List<Modalidad> getModalidades() {
		return modalidadDao.getModalidades();
	}
	

    @RequestMapping(value = "/get", method = RequestMethod.GET)
    @ResponseBody
	public List<Modalidad> getModalidadesPorCarateristicas(
			@Param("id") Long id,
			@Param("descripcion") String descripcion,
			@Param("distancia") String distancia,
			@Param("idDisciplina") Long idDisciplina
			) {
   	
		Modalidad modalidad = new Modalidad().withId(id).
				withDescripcion(descripcion).
				withDistancia(distancia).
				withIdDisciplina(idDisciplina);
		
		return modalidadDao.getModalidadesPorCarateristicas(modalidad);
	}


	public void setModalidadDao(ModalidadDao modalidadDao) {
		this.modalidadDao = modalidadDao;
	}


}
