package org.diplomaUPV.app.rest.controller;

import java.io.IOException;
import java.text.ParseException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.diplomaUPV.app.rest.dao.EventoDao;
import org.diplomaUPV.app.rest.dao.ModalidadDao;
import org.diplomaUPV.app.rest.entity.Evento;
import org.diplomaUPV.app.rest.entity.Modalidad;
import org.diplomaUPV.app.scrapping.ScraperCalendarioCarrerasPopulares;
import org.diplomaUPV.app.scrapping.Utils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;


@Controller
@RequestMapping("/scrappingEventos")
public class ScrappingRestController{
	
	@Autowired
	private EventoDao eventoDao; 
	
	@Autowired
	private ModalidadDao modalidadDao; 
	
	@RequestMapping(value = "/CarrerasPopulares", method = RequestMethod.GET)
    @ResponseBody
	public void doScrappingEventos() {
		List<Modalidad> modalidades = modalidadDao.getModalidades();
		Map<String, Modalidad> listadoModalidades = hashListadoModalidades(modalidades);
    	ScraperCalendarioCarrerasPopulares sCarrerasPopulares = new ScraperCalendarioCarrerasPopulares();
    	List<Evento> eventosCarrerasPopulares;
		try {
			eventosCarrerasPopulares = sCarrerasPopulares.extraerInfo(listadoModalidades);
			for (int i = 0; i < eventosCarrerasPopulares.size(); i++) {
	    		eventoDao.insertEvento(eventosCarrerasPopulares.get(i));
			}
		} catch (IOException e) {
			e.printStackTrace();
		} catch (ParseException e) {
			e.printStackTrace();
		}	
	}
    
	private Map<String, Modalidad> hashListadoModalidades(List<Modalidad> listadoModalidades) {
		Map<String , Modalidad> modalidades = new HashMap<String , Modalidad>();
		for (int i = 0; i < listadoModalidades.size(); i++) {
			Modalidad modalidadSeleccionada = listadoModalidades.get(i);
			modalidades.put(modalidadSeleccionada.getDescripcion().toUpperCase(), modalidadSeleccionada);
		}
		return modalidades;
	}
    
	public void setEventoDao(EventoDao eventoDao) {
		this.eventoDao = eventoDao;
	}
	
	public void setModalidadDao(ModalidadDao modalidadDao) {
		this.modalidadDao = modalidadDao;
	}
}
