package org.diplomaUPV.app.scrapping;

import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.HashMap;
import java.util.Map;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpression;
import javax.xml.xpath.XPathFactory;

import org.diplomaUPV.app.rest.entity.Modalidad;
import org.w3c.dom.Document;

public class Utils {	

//	@SuppressWarnings("serial")
//	static final Map<Integer , String> comunidadesAutonomas = new HashMap<Integer , String>() {{
//		comunidadesAutonomas.put(1, "ANDALUCIA");
//		comunidadesAutonomas.put(2, "ARAGON");
//		comunidadesAutonomas.put(3, "ASTURIAS");
//		comunidadesAutonomas.put(4, "CANTABRIA");
//		comunidadesAutonomas.put(5, "CASTILLA LA MANCHA");
//		comunidadesAutonomas.put(6, "CASTILLA-LEON");
//		comunidadesAutonomas.put(7, "CATALUÑA");
//		comunidadesAutonomas.put(8, "CEUTA");
//		comunidadesAutonomas.put(9, "MADRID");
//		comunidadesAutonomas.put(10, "COMUNIDAD VALENCIANA");
//		comunidadesAutonomas.put(11, "EXTREMADURA");
//		comunidadesAutonomas.put(12, "GALICIA");
//		comunidadesAutonomas.put(13, "ISLAS BALEARES");
//		comunidadesAutonomas.put(14, "ISLAS CANARIAS");
//		comunidadesAutonomas.put(15, "LA RIOJA");
//		comunidadesAutonomas.put(16, "MELILLA");
//		comunidadesAutonomas.put(17, "NAVARRA");
//		comunidadesAutonomas.put(18, "PAIS VASCO");
//		comunidadesAutonomas.put(19, "MURCIA");
//	}};
//
//
//	@SuppressWarnings("serial")
//	static final Map<String , Modalidad> modalidades = new HashMap<String , Modalidad>() {{
//		modalidades.put("Maratón", new Modalidad(new Long(1), "Maratón", null));
//		modalidades.put("Media Maratón", new Modalidad(new Long(2), "Media Maratón", null));
//		modalidades.put("10.000 mts", new Modalidad(new Long(3), "10.000 mts", null));
//		modalidades.put("BTT", new Modalidad(new Long(4), "BTT", null));
//		modalidades.put("Cicloturismo", new Modalidad(new Long(5), "Cicloturismo", null));
//		modalidades.put("Carrera Popular", new Modalidad(new Long(6), "Carrera Popular", null));
//		modalidades.put("Cross urbano", new Modalidad(new Long(7), "Cross urbano", null));
//		modalidades.put("Legua", new Modalidad(new Long(8), "Legua", null));
//		modalidades.put("Milla", new Modalidad(new Long(9), "Milla", null));
//		modalidades.put("Carrera por Montaña", new Modalidad(new Long(10), "Carrera por Montaña", null));
//		modalidades.put("Maratón Montaña", new Modalidad(new Long(11), "Maratón Montaña", null));
//		modalidades.put("Fondo / Gran Fondo", new Modalidad(new Long(12), "Fondo / Gran Fondo", null));
//		modalidades.put("Otros", new Modalidad(new Long(13), "Otros", null));
//		modalidades.put("Subida", new Modalidad(new Long(14), "Subida", null));
//		modalidades.put("Marcha senderista", new Modalidad(new Long(15), "Marcha senderista", null));
//		modalidades.put("Triatlón", new Modalidad(new Long(16), "Triatlón", null));
//		modalidades.put("Duatlón", new Modalidad(new Long(17), "Duatlón", null));
//		modalidades.put("Cross - Campo através", new Modalidad(new Long(18), "Cross - Campo através", null));
//		modalidades.put("Carreras de obstaculos", new Modalidad(new Long(19), "Carreras de obstaculos", null));
//		modalidades.put("Ultra Trail", new Modalidad(new Long(20), "Ultra Trail", null));
//	}};


	public static String getLatLongPositions(String address) throws Exception{
		int responseCode = 0;
		String api = "http://maps.googleapis.com/maps/api/geocode/xml?address=" + URLEncoder.encode(address, "UTF-8") + "&sensor=true";
		System.out.println("URL : "+api);
		URL url = new URL(api);
		HttpURLConnection httpConnection = (HttpURLConnection)url.openConnection();
		httpConnection.connect();
		responseCode = httpConnection.getResponseCode();
		if(responseCode == 200){
			DocumentBuilder builder = DocumentBuilderFactory.newInstance().newDocumentBuilder();;
			Document document = builder.parse(httpConnection.getInputStream());
			XPathFactory xPathfactory = XPathFactory.newInstance();
			XPath xpath = xPathfactory.newXPath();
			XPathExpression expr = xpath.compile("/GeocodeResponse/status");
			String status = (String)expr.evaluate(document, XPathConstants.STRING);
			if(status.equals("OK")){
				expr = xpath.compile("//geometry/location/lat");
				String latitude = (String)expr.evaluate(document, XPathConstants.STRING);
				expr = xpath.compile("//geometry/location/lng");
				String longitude = (String)expr.evaluate(document, XPathConstants.STRING);
				return new String(latitude + "," + longitude);
			}
			else{
				throw new Exception("Error from the API - response status: "+status);
			}
		}
		return null;
	}
}
