package com.diplomaAndroidUpv.org.competicionesDeportivas.Entity;

import java.text.SimpleDateFormat;
import java.util.Comparator;
import java.util.Date;


public class Competition implements Comparator<Competition>{
	private static final long serialVersionUID = 1L;
	private Long id;
	private String titulo;
	private Long idModalidad;
	private String localidad;
	private Long idComunidadAutonoma;
	private String localidadGmaps;
	private String urlEvento;
	private Date fecha;
	private String infoExtra;
	private Date fechaCreacion;
	private String urlCartel;
	private Long puntuacionPositiva;
	private Long puntuacionNegativa; 
	
	
	public Competition(){}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Competition withId(Long id) {
		this.id = id;
		return this;
	}
	
	public String getTitulo() {
		return titulo;
	}

	public void setTitulo(String titulo) {
		this.titulo = titulo;
	}

	public Competition withTitulo(String titulo) {
		this.titulo = titulo;
		return this;
	}
	
	public Long getIdModalidad() {
		return idModalidad;
	}

	public void setIdModalidad(Long idModalidad) {
		this.idModalidad = idModalidad;
	}

	public Competition withIdModalidad(Long idModalidad) {
		this.idModalidad = idModalidad;
		return this;
	}
	
	public Long getIdComunidadAutonoma() {
		return idComunidadAutonoma;
	}

	public void setIdComunidadAutonoma(Long idComunidadAutonoma) {
		this.idComunidadAutonoma = idComunidadAutonoma;
	}

	public Competition withIdComunidadAutonoma(Long idComunidadAutonoma) {
		this.idComunidadAutonoma = idComunidadAutonoma;
		return this;
	}
	
	public String getLocalidad() {
		return localidad;
	}

	public void setLocalidad(String localidad) {
		this.localidad = localidad;
	}

	public Competition withLocalidad(String localidad) {
		this.localidad = localidad;
		return this;
	}
	
	public String getLocalidadGmaps() {
		return localidadGmaps;
	}

	public void setLocalidadGmaps(String localidadGmaps) {
		this.localidadGmaps = localidadGmaps;
	}

	public Competition withLocalidadGmaps(String localidadGmaps) {
		this.localidadGmaps = localidadGmaps;
		return this;
	}
	
	public String getUrlEvento() {
		return urlEvento;
	}

	public void setUrlEvento(String urlEvento) {
		this.urlEvento = urlEvento;
	}

	public Competition withUrlEvento(String urlEvento) {
		this.urlEvento = urlEvento;
		return this;
	}
	
	public Date getFecha() {
		return fecha;
	}

	public void setFecha(Date fecha) {
		this.fecha = fecha;
	}
	
	public Competition withFecha(Date fecha) {
		this.fecha = fecha;
		return this;
	}

	public String getFechaString() {
		SimpleDateFormat sdf = new SimpleDateFormat("dd-MM-yyyy");
		String fechaString = sdf.format(this.fecha);
		return fechaString;
	}

	public String getInfoExtra() {
		return infoExtra;
	}
	
	public void setInfoExtra(String infoExtra) {
		this.infoExtra = infoExtra;
	}
	
	public Competition withInfoExtra(String infoExtra) {
		this.infoExtra = infoExtra;
		return this;
	}

	public Date getFechaCreacion() {
		return fechaCreacion;
	}
	
	public void setFechaCreacion(Date fechaCreacion) {
		this.fechaCreacion = fechaCreacion;
	}
	
	public Competition withFechaCreacion(Date fechaCreacion) {
		this.fechaCreacion = fechaCreacion;
		return this;
	}
	
	public String getUrlCartel() {
		return urlCartel;
	}

	public void setUrlCartel(String urlCartel) {
		this.urlCartel = urlCartel;
	}

	public Competition withUrlCartel(String urlCartel) {
		this.urlCartel = urlCartel;
		return this;
	}
	
	public Long getPuntuacionPositiva() {
		return puntuacionPositiva;
	}

	public void setPuntuacionPositiva(Long puntuacionPositiva) {
		this.puntuacionPositiva = puntuacionPositiva;
	}

	public Competition withPuntuacionPositiva(Long puntuacionPositiva) {
		this.puntuacionPositiva = puntuacionPositiva;
		return this;
	}
	
	public Long getPuntuacionNegativa() {
		return puntuacionNegativa;
	}

	public void setPuntuacionNegativa(Long puntuacionNegativa) {
		this.puntuacionNegativa = puntuacionNegativa;
	}

	public Competition withPuntuacionNegativa(Long puntuacionNegativa) {
		this.puntuacionNegativa = puntuacionNegativa;
		return this;
	}

	@Override
	public String toString() {
		return "Track [id=" + id + ", titulo=" + titulo + ", idModalidad=" + idModalidad + ", localidad=" + localidad + ", "
				+ ", idComunidadAutonoma=" + idComunidadAutonoma + ", " + "localidadGmaps=" + localidadGmaps + "urlEvento=" + urlEvento + 
				", fecha=" + fecha + ", infoExtra=" + infoExtra + ", fechaCreacion=" + fechaCreacion +
				", urlCartel=" + urlCartel + ", puntuacionPositiva=" + puntuacionPositiva + ", puntuacionNegativa=" + puntuacionNegativa +"]";
	}

	@Override
	public int compare(Competition competicion1, Competition competicion2) {
		return Comparators.FECHA.compare(competicion1, competicion2);
	}

	public static class Comparators {

        //Collections.sort(studentList, Student.Comparators.AGE);

		public static Comparator<Competition> FECHA = new Comparator<Competition>() {
			@Override
			public int compare(Competition c1, Competition c2) {
				return c1.getFecha().compareTo(c2.getFecha());
			}
		};
		public static Comparator<Competition> MODALIDAD = new Comparator<Competition>() {
			@Override
			public int compare(Competition c1, Competition c2) {
				if (c1.getIdModalidad() < c2.getIdModalidad()) return -1;
				if (c1.getIdModalidad() > c2.getIdModalidad()) return 1;
				return 0;
			}
		};
	}

}

