package com.diplomaAndroidUpv.org.competicionesDeportivas.RecyclerView.Categories;

import android.support.v7.widget.RecyclerView;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;

import com.diplomaAndroidUpv.org.competicionesDeportivas.R;


public class RecyclerItemViewHolder extends RecyclerView.ViewHolder {

    private final TextView mItemTextView;
    private final ImageView mImageView;

    public RecyclerItemViewHolder(final View parent, TextView itemTextView, ImageView imageView) {
        super(parent);
        mItemTextView = itemTextView;
        mImageView = imageView;
    }

    public static RecyclerItemViewHolder newInstance(View parent) {
        TextView itemTextView = (TextView) parent.findViewById(R.id.itemTextView);
        ImageView imageView =  (ImageView) parent.findViewById(R.id.imageView);
        return new RecyclerItemViewHolder(parent, itemTextView, imageView);
    }

    public void setItemText(CharSequence text) {
        mItemTextView.setText(text);
    }

    public void setImageView(int resource) {
        mImageView.setImageResource(resource);
    }

}
