package com.diplomaAndroidUpv.org.competicionesDeportivas.RecyclerView.Competitions;

import android.content.Context;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Toast;

import com.diplomaAndroidUpv.org.competicionesDeportivas.Entity.Competition;
import com.diplomaAndroidUpv.org.competicionesDeportivas.Listener.ItemClickListener;
import com.diplomaAndroidUpv.org.competicionesDeportivas.R;
import com.diplomaAndroidUpv.org.competicionesDeportivas.Util.DialogCreator;

import java.util.List;

public class RecyclerAdapterCompetition extends RecyclerView.Adapter<RecyclerView.ViewHolder> {
    private static final int TYPE_ITEM = 1;
    private List<Competition> mItemList;
    private Context context;

    public RecyclerAdapterCompetition(List<Competition> itemList) {
        mItemList = itemList;
    }

    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        context = parent.getContext();
        final View view = LayoutInflater.from(context).inflate(R.layout.recycler_competition_item, parent, false);
        return RecyclerItemViewHolderCompetition.newInstance(view, context);
    }

    @Override
    public void onBindViewHolder(RecyclerView.ViewHolder viewHolder, final int position) {
        RecyclerItemViewHolderCompetition holder = (RecyclerItemViewHolderCompetition) viewHolder;
        final Competition itemSeleccionado = mItemList.get(position);
        holder.setCompeticionSeleccionada(itemSeleccionado);
        holder.setClickListener(new ItemClickListener() {
            @Override
            public void onClick(View view, boolean isLongClick) {
                if (isLongClick) {
                    DialogCreator.createDialogCompetitionOptions(view.getContext(), itemSeleccionado).show();
                }
            }
        });
    }

    public int getBasicItemCount() {
        return mItemList == null ? 0 : mItemList.size();
    }

    @Override
    public int getItemViewType(int position) {return TYPE_ITEM;}

    @Override
    public int getItemCount() {return getBasicItemCount(); }

}