package com.diplomaAndroidUpv.org.competicionesDeportivas.RecyclerView.Competitions;

import android.content.Context;
import android.graphics.Paint;
import android.graphics.drawable.GradientDrawable;
import android.graphics.drawable.LayerDrawable;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.Shape;
import android.support.v7.widget.RecyclerView;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;

import com.diplomaAndroidUpv.org.competicionesDeportivas.Entity.Competition;
import com.diplomaAndroidUpv.org.competicionesDeportivas.Listener.ItemClickListener;
import com.diplomaAndroidUpv.org.competicionesDeportivas.R;


public class RecyclerItemViewHolderCompetition extends RecyclerView.ViewHolder implements View.OnClickListener, View.OnLongClickListener{

    private TextView competicionTitulo, competicionLocalidad, competicionFecha;
    private TextView mtextViewLogo;
    private ItemClickListener clickListener;
    private Context context;

    public RecyclerItemViewHolderCompetition(final View parent, Context context) {
        super(parent);
        parent.setOnClickListener(this);
        parent.setOnLongClickListener(this);
        this.context = context;
        this.competicionTitulo = (TextView) parent.findViewById(R.id.competicionTitulo);
        this.competicionFecha = (TextView) parent.findViewById(R.id.competicionFecha);
        this.competicionLocalidad = (TextView) parent.findViewById(R.id.competicionLocalidad);
        this.mtextViewLogo =  (TextView) parent.findViewById(R.id.textViewLogo);
    }


    public static RecyclerItemViewHolderCompetition newInstance(View parent, Context context) {
        return new RecyclerItemViewHolderCompetition(parent, context);
    }

    public void setCompeticionSeleccionada(Competition competicionSeleccionada) {
        this.competicionTitulo.setText(competicionSeleccionada.getTitulo());
        this.competicionLocalidad.setText(competicionSeleccionada.getLocalidad());
        this.competicionFecha.setText(competicionSeleccionada.getFechaString());
        setImageCompetition(competicionSeleccionada);
    }

    private void setImageCompetition(Competition competicionSeleccionada) {
        Long modalidad = competicionSeleccionada.getIdModalidad();
        LayerDrawable bgDrawable = (LayerDrawable)this.mtextViewLogo.getBackground();
        final GradientDrawable shape = (GradientDrawable)bgDrawable.findDrawableByLayerId(R.id.itemShape);


        switch (modalidad.intValue()){
            case 1:
                this.mtextViewLogo.setText(R.string.maraton);
                shape.setColor(this.context.getResources().getColor(R.color.Chartreuse));
                break;
            case 2:
                this.mtextViewLogo.setText(R.string.media_maraton);
                shape.setColor(this.context.getResources().getColor(R.color.MediumAquamarine));
                break;
            case 3:
                this.mtextViewLogo.setText(R.string.diez);
                shape.setColor(this.context.getResources().getColor(R.color.MediumSlateBlue));
                break;
            case 4:
                this.mtextViewLogo.setText(R.string.btt);
                shape.setColor(this.context.getResources().getColor(R.color.DarkSlateBlue));
                break;
            case 5:
                this.mtextViewLogo.setText(R.string.cicloturismo);
                shape.setColor(this.context.getResources().getColor(R.color.MediumSeaGreen));
                break;
            case 6:
                this.mtextViewLogo.setText(R.string.carrera_popular);
                shape.setColor(this.context.getResources().getColor(R.color.LightSeaGreen));
                break;
            case 7:
                this.mtextViewLogo.setText(R.string.cross);
                shape.setColor(this.context.getResources().getColor(R.color.DarkTurquoise));
                break;
            case 8:
                this.mtextViewLogo.setText(R.string.legua);
                shape.setColor(this.context.getResources().getColor(R.color.DarkBlue));
                break;
            case 9:
                this.mtextViewLogo.setText(R.string.milla);
                shape.setColor(this.context.getResources().getColor(R.color.Chartreuse));
                break;
            case 10:
                this.mtextViewLogo.setText(R.string.carrera_monta);
                shape.setColor(this.context.getResources().getColor(R.color.PaleVioletRed));
                break;
            case 11:
                this.mtextViewLogo.setText(R.string.maraton_monta);
                shape.setColor(this.context.getResources().getColor(R.color.Maroon));
                break;
            case 12:
                this.mtextViewLogo.setText(R.string.fondo);
                shape.setColor(this.context.getResources().getColor(R.color.SandyBrown));
                break;
            case 13:
                this.mtextViewLogo.setText(R.string.otros);
                shape.setColor(this.context.getResources().getColor(R.color.DarkSalmon));
                break;
            case 14:
                this.mtextViewLogo.setText(R.string.subida);
                shape.setColor(this.context.getResources().getColor(R.color.Orchid));
                break;
            case 15:
                this.mtextViewLogo.setText(R.string.marcha_sende);
                shape.setColor(this.context.getResources().getColor(R.color.Tan));
                break;
            case 16:
                this.mtextViewLogo.setText(R.string.triatlon);
                shape.setColor(this.context.getResources().getColor(R.color.FireBrick));
                break;
            case 17:
                this.mtextViewLogo.setText(R.string.duatlon);
                shape.setColor(this.context.getResources().getColor(R.color.LightSteelBlue));
                break;
            case 18:
                this.mtextViewLogo.setText(R.string.cross);
                shape.setColor(this.context.getResources().getColor(R.color.GreenYellow));
                break;
            case 19:
                this.mtextViewLogo.setText(R.string.carrera_obs);
                shape.setColor(this.context.getResources().getColor(R.color.DarkOrchid));
                break;
            case 20:
                this.mtextViewLogo.setText(R.string.ultratrail);
                shape.setColor(this.context.getResources().getColor(R.color.MediumPurple));
                break;
            default:
                this.mtextViewLogo.setText(R.string.otros);
                shape.setColor(this.context.getResources().getColor(R.color.DarkSeaGreen));
        }
    }

    public void setClickListener(ItemClickListener itemClickListener) {
        this.clickListener = itemClickListener;
    }

    @Override
    public void onClick(View view) {
        clickListener.onClick(view, false);
    }

    @Override
    public boolean onLongClick(View view) {
        clickListener.onClick(view, true);
        return true;
    }

}
