package com.diplomaAndroidUpv.org.competicionesDeportivas.Util;

import android.content.Context;
import android.preference.PreferenceManager;

import com.diplomaAndroidUpv.org.competicionesDeportivas.Entity.Competition;
import com.google.android.gms.maps.model.LatLng;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;


public class CompetitionsFilter implements Serializable{

    String filterText;
    Date initDate, endDate;
    Long kmDistance;
    Long cA;
    Long modalidad;


    public List<Competition> applyFilter(List<Competition> competitionsList, Context context) {
        ArrayList<Competition> filteredCompetitionsList = new ArrayList<Competition>();
        ArrayList<Competition> textFilteredCompetitionsList = new ArrayList<Competition>();

        if(competitionsList != null){
            for (int i = 0; i < competitionsList.size() ; i++){
                Competition competitionSel = competitionsList.get(i);
                if(getModalidad() != null && competitionSel.getIdModalidad().longValue() == getModalidad().longValue() + 1){
                    filteredCompetitionsList.add(competitionSel);
                    continue;
                }
                if(getcA() != null && competitionSel.getIdComunidadAutonoma().longValue() == getcA().longValue() + 1){
                    filteredCompetitionsList.add(competitionSel);
                    continue;
                }
                if(getInitDate() != null && getEndDate() != null){
                    if(competitionSel.getFecha().compareTo(getInitDate()) >= 0 && competitionSel.getFecha().compareTo(getEndDate()) <= 0){
                        filteredCompetitionsList.add(competitionSel);
                        continue;
                    }
                }
                if(getInitDate() != null){
                    if(competitionSel.getFecha().compareTo(getInitDate()) >= 0){
                        filteredCompetitionsList.add(competitionSel);
                        continue;
                    }
                }
                if(getEndDate() != null){
                    if(competitionSel.getFecha().compareTo(getEndDate()) <= 0){
                        filteredCompetitionsList.add(competitionSel);
                        continue;
                    }
                }
                if(getKmDistance() != null){
                    double myLatitude = Double.longBitsToDouble(PreferenceManager.getDefaultSharedPreferences(context).getLong("myLat", 0));
                    double myLongitude = Double.longBitsToDouble(PreferenceManager.getDefaultSharedPreferences(context).getLong("myLong", 0));
                    String[] competitionCoordinates = competitionSel.getLocalidadGmaps().split(",");
                    float distance = Utils.distFrom(new Double(myLatitude).floatValue(), new Double(myLongitude).floatValue(), new Double(competitionCoordinates[0]).floatValue(), new Double(competitionCoordinates[1]).floatValue());
                    if(distance <= getKmDistance()){
                        filteredCompetitionsList.add(competitionSel);
                        continue;
                    }
                }
                if(getModalidad() == null && getInitDate() == null && getEndDate() == null && getcA() == null && getKmDistance() == null){
                    filteredCompetitionsList.add(competitionSel);
                    continue;
                }
            }

            if(filteredCompetitionsList != null){
                if(getFilterText() == null){
                    textFilteredCompetitionsList = filteredCompetitionsList;
                }else{
                    for (int i = 0; i < filteredCompetitionsList.size() ; i++) {
                        Competition competitionSel = filteredCompetitionsList.get(i);
                        if(getFilterText() != null && (competitionSel.getTitulo().toUpperCase().contains(getFilterText().toUpperCase()) || getFilterText().equals(""))){
                            textFilteredCompetitionsList.add(competitionSel);
                            continue;
                        }
                    }
                }
            }

        }
        return textFilteredCompetitionsList;
    }

    public String getFilterText() {
        return filterText;
    }

    public void setFilterText(String filterText) {
        this.filterText = filterText;
    }

    public CompetitionsFilter withFilterText(String filterText) {
        this.filterText = filterText;
        return this;
    }


    public Long getKmDistance() {
        return kmDistance;
    }

    public void setKmDistance(Long kmDistance) {
        this.kmDistance = kmDistance;
    }


    public Long getcA() {
        return cA;
    }

    public void setcA(Long cA) {
        this.cA = cA;
    }


    public Long getModalidad() {
        return modalidad;
    }

    public void setModalidad(Long modalidad) {
        this.modalidad = modalidad;
    }

    public Date getInitDate() {
        return initDate;
    }

    public void setInitDate(Date initDate) {
        this.initDate = initDate;
    }

    public Date getEndDate() {
        return endDate;
    }

    public void setEndDate(Date endDate) {
        this.endDate = endDate;
    }

}
